<?php
class ControllerExtensionPaymentNummus extends Controller {
  private $error = array();
 
  public function index() {
    $this->load->language('extension/payment/nummus');
    $this->document->setTitle($this->language->get('heading_title'));
    $this->load->model('setting/setting');
 
    if (($this->request->server['REQUEST_METHOD'] == 'POST')) {
      $this->model_setting_setting->editSetting('payment_nummus', $this->request->post);
      $this->session->data['success'] = $this->language->get('text_success');
      $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token']. '&type=payment', true));
    }
 
	$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/payment/nochex', 'user_token=' . $this->session->data['user_token'], true)
		); 
 
    $data['action'] = $this->url->link('extension/payment/nummus', 'user_token=' . $this->session->data['user_token'], true);
    $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);
 
    if (isset($this->request->post['payment_nummus_email'])) {
      $data['payment_nummus_email'] = $this->request->post['payment_nummus_email'];
    } else {
      $data['payment_nummus_email'] = $this->config->get('payment_nummus_email');
    }
        
    if (isset($this->request->post['payment_nummus_password'])) {
      $data['payment_nummus_password'] = $this->request->post['payment_nummus_password'];
    } else {
      $data['payment_nummus_password'] = $this->config->get('payment_nummus_password');
    }
            
    if (isset($this->request->post['payment_nummus_gateway'])) {
      $data['payment_nummus_gateway'] = $this->request->post['payment_nummus_gateway'];
    } else {
      $data['payment_nummus_gateway'] = $this->config->get('payment_nummus_gateway');
    }

    if (isset($this->request->post['payment_nummus_status'])) {
      $data['payment_nummus_status'] = $this->request->post['payment_nummus_status'];
    } else {
      $data['payment_nummus_status'] = $this->config->get('payment_nummus_status');
    }
        
    if (isset($this->request->post['nummus_order_status_id'])) {
      $data['nummus_order_status_id'] = $this->request->post['nummus_order_status_id'];
    } else {
      $data['nummus_order_status_id'] = $this->config->get('nummus_order_status_id');
    }
 
    $this->load->model('localisation/order_status');
    $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
    $this->template = 'payment/nummus.tpl';
            
    $data['header'] = $this->load->controller('common/header');
    $data['column_left'] = $this->load->controller('common/column_left');
    $data['footer'] = $this->load->controller('common/footer');
 
    $this->response->setOutput($this->load->view('extension/payment/nummus', $data));
  }
}
