<?php
// Nochex via form will work for both simple "Seller" account and "Merchant" account holders
// Nochex via APC maybe only avaiable to "Merchant" account holders only - site docs a bit vague on this point
class ControllerExtensionPaymentNummus extends Controller {
	public function index() {
		$this->load->language('extension/payment/nummus');

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);


		$data['amount'] = $this->currency->format($order_info['total'], 'SRD', false, false);
		$data['order_id'] = $this->session->data['order_id'];

		$data['billing_fullname'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];

		if ($order_info['payment_address_2']) {
			$data['billing_address']  = $order_info['payment_address_1'] . "\r\n" . $order_info['payment_address_2'] . "\r\n" . $order_info['payment_city'] . "\r\n" . $order_info['payment_zone'] . "\r\n";
		} else {
			$data['billing_address']  = $order_info['payment_address_1'] . "\r\n" . $order_info['payment_city'] . "\r\n" . $order_info['payment_zone'] . "\r\n";
		}

		$data['billing_postcode'] = $order_info['payment_postcode'];
		$gateway = $this->config->get('payment_nummus_gateway');
		$email = $this->config->get('payment_nummus_email');
		$password = $this->config->get('payment_nummus_password');
		$c_url = $gateway.'/WebshopAuth/'.$email.'/'.$password.'/'.$data['order_id'].'/'.$data['amount'];
		$curl = curl_init($c_url);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_HTTPHEADER, array("Content-type: application/json"));
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLINFO_HEADER_OUT, true);
		$result = curl_exec($curl);
		$response = json_decode($result);
		$data['action'] = $gateway.'/ScanController.php?TokenID='.$response->Resp.'&?Email='.$email;
		if($response){
			if($response->Code==1){
			    $api_msg = 'Service Offline';
			}else if($response->Code==2){
			    $api_msg = 'Account Violation (IP Black-Listed)';
			}else if($response->Code==3){
			    $api_msg = 'Input Not Allowed (Dirty/SQL)';
			}else if($response->Code==4){
			    $api_msg = 'Account Inactive';
			}else if($response->Code==5){
			    $api_msg = 'Password Incorrect';
			}else{
			    $api_msg = 'Empty response Msg from Api';
			}
		}

		if ($this->cart->hasShipping()) {
			$data['delivery_fullname'] = $order_info['shipping_firstname'] . ' ' . $order_info['shipping_lastname'];

			if ($order_info['shipping_address_2']) {
				$data['delivery_address'] = $order_info['shipping_address_1'] . "\r\n" . $order_info['shipping_address_2'] . "\r\n" . $order_info['shipping_city'] . "\r\n" . $order_info['shipping_zone'] . "\r\n";
			} else {
				$data['delivery_address'] = $order_info['shipping_address_1'] . "\r\n" . $order_info['shipping_city'] . "\r\n" . $order_info['shipping_zone'] . "\r\n";
			}

			$data['delivery_postcode'] = $order_info['shipping_postcode'];
		} else {
			$data['delivery_fullname'] = $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];

			if ($order_info['payment_address_2']) {
				$data['delivery_address'] = $order_info['payment_address_1'] . "\r\n" . $order_info['payment_address_2'] . "\r\n" . $order_info['payment_city'] . "\r\n" . $order_info['payment_zone'] . "\r\n";
			} else {
				$data['delivery_address'] = $order_info['shipping_address_1'] . "\r\n" . $order_info['payment_city'] . "\r\n" . $order_info['payment_zone'] . "\r\n";
			}

			$data['delivery_postcode'] = $order_info['payment_postcode'];
		}

		$data['email_address'] = $order_info['email'];
		$data['customer_phone_number']= $order_info['telephone'];
		$data['success_url'] = $this->url->link('checkout/success', '', true);
		$data['cancel_url'] = $this->url->link('checkout/payment', '', true);
		$data['declined_url'] = $this->url->link('extension/payment/nummus/callback', 'method=decline', true);
		$data['callback_url'] = $this->url->link('extension/payment/nummus/callback', 'order=' . $this->session->data['order_id'], true);

		#$data['action'] = $c_url;
		return $this->load->view('extension/payment/nummus', $data);
	}

	public function callback() {
		$this->load->language('extension/payment/nummus');

		if (isset($this->request->get['method']) && $this->request->get['method'] == 'decline') {
			$this->session->data['error'] = $this->language->get('error_declined');

			$this->response->redirect($this->url->link('checkout/cart'));
		}

		if (isset($this->request->post['order_id'])) {
			$order_id = $this->request->post['order_id'];
		} else {
			$order_id = 0;
		}

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($order_id);

		if (!$order_info) {
			$this->session->data['error'] = $this->language->get('error_no_order');

			$this->response->redirect($this->url->link('checkout/cart'));
		}

		// Fraud Verification Step.
		$request = '';

		foreach ($this->request->post as $key => $value) {
			$request .= '&' . $key . '=' . urlencode(stripslashes($value));
		}

		// Since it returned, the customer should see success.
		// It's up to the store owner to manually verify payment.
		$this->response->redirect($this->url->link('checkout/success', '', true));
	}
}
?>
